import * as Effects from "./effects";
export declare type Dispatch<A> = (value: A) => void;
export declare type Effect<Action> = Array<(dispatch: Dispatch<Action>) => void>;
export declare type StateEffectPair<State, Action> = [State, Effect<Action>];
export declare type Reducer<State, Action> = (prevState: State, action: Action) => StateEffectPair<State, Action>;
export declare type ReducerState<R extends Reducer<any, any>> = R extends Reducer<infer S, any> ? S : never;
export declare type ReducerAction<R extends Reducer<any, any>> = R extends Reducer<any, infer A> ? A : never;
export declare type ReducerStateEffectPair<R extends Reducer<any, any>> = R extends Reducer<infer S, infer A> ? [S, Effect<A>] : never;
export declare function useElmish<R extends Reducer<any, any>, I>(reducer: R, initializer: () => ReducerStateEffectPair<R>): [ReducerState<R>, Dispatch<ReducerAction<R>>];
export { Effects };
export default useElmish;
