"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const Effects = __importStar(require("./effects"));
exports.Effects = Effects;
function useElmish(reducer, initializer) {
    let effects = react_1.useRef([]);
    let [state, dispatch] = react_1.useReducer((prevState, action) => {
        let nextStateAndEffect = reducer(prevState, action);
        effects.current = [...effects.current, ...nextStateAndEffect[1]];
        return nextStateAndEffect[0];
    }, null, _ => {
        const initialState = initializer();
        effects.current = initialState[1];
        return initialState[0];
    });
    react_1.useEffect(() => {
        const eff = [...effects.current];
        if (effects.current.length > 0) {
            effects.current = [];
            eff.forEach((x) => x(dispatch));
        }
    }, [effects.current]);
    return [state, dispatch];
}
exports.useElmish = useElmish;
exports.default = useElmish;
