"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_hooks_1 = require("@testing-library/react-hooks");
const index_1 = __importStar(require("./index"));
test("should act as a reducer", () => {
    const { result } = react_hooks_1.renderHook(() => index_1.default((prev, action) => {
        if (action == "increment") {
            return [prev + 1, index_1.Effects.none()];
        }
        else {
            return [prev, index_1.Effects.none()];
        }
    }, () => [0, index_1.Effects.none()]));
    react_hooks_1.act(() => {
        result.current[1]("increment");
    });
    expect(result.current[0]).toBe(1);
});
test("should execute effects", () => __awaiter(this, void 0, void 0, function* () {
    const { result, waitForNextUpdate } = react_hooks_1.renderHook(() => index_1.default((prev, action) => {
        if (action == "startSinging") {
            return [{ state: "singing" }, index_1.Effects.action("stopSinging")];
        }
        else if (action == "stopSinging") {
            return [{ state: "stoppedSinging" }, index_1.Effects.none()];
        }
        else {
            return [prev, index_1.Effects.none()];
        }
    }, () => [{ state: "notStartedSinging" }, index_1.Effects.none()]));
    react_hooks_1.act(() => {
        result.current[1]("startSinging");
    });
    expect(result.current[0].state).toBe("stoppedSinging");
}));
test("should not trigger rerender if no effects and state the same", () => __awaiter(this, void 0, void 0, function* () {
    let renderCount = 0;
    const { result } = react_hooks_1.renderHook(() => {
        ++renderCount;
        return index_1.default((prev, action) => {
            if (action == "increment") {
                return [prev + 1, index_1.Effects.none()];
            }
            else {
                return [prev, index_1.Effects.none()];
            }
        }, () => [0, index_1.Effects.none()]);
    });
    react_hooks_1.act(() => {
        result.current[1]("other");
    });
    expect(result.current[0]).toBe(0);
    expect(renderCount).toBe(1);
}));
